#version 150 core

in vec2 varyingTexCoord;

uniform int filterSize;
uniform sampler1D filterCoefficients;
uniform sampler2DRect image;

uniform bool horizontal;

out vec4 outputColor;

void main()
{
	vec3 color = vec3(0.0, 0.0, 0.0);

	if(horizontal)
	{
		for(int filterPos = 0; filterPos < filterSize; filterPos++)
		{
			color += texture(image, varyingTexCoord
				+ (vec2(1.0 * filterPos - floor(filterSize/2), 0.0))).xyz
				* vec3(texture(filterCoefficients, filterPos * (1.0/filterSize)).x);
		}
	} else
	{
		for(int filterPos = 0; filterPos < filterSize; filterPos++)
		{
			color += texture(image, varyingTexCoord
				+ (vec2(0.0, 1.0 * filterPos - floor(filterSize/2)))).xyz
				* vec3(texture(filterCoefficients, filterPos * (1.0/filterSize)).x);
		}
	}

	outputColor = vec4(color, 1.0);
}