#version 150 core

in vec2 varyingTexCoord;

uniform sampler2DRect image;
uniform float thresh;

out vec4 outputColor;

const float alpha = 0.5/sin(3.14159/8);

vec2 recalculateVec2(vec2 normalizedVec2)
{
	return round(alpha * ((normalizedVec2.xy * 2.0) - normalize(vec2(1.0))));
}

void main()
{
	// magdir holds { dx, dy, mag, direct }

	vec4 magdir = texture(image, varyingTexCoord);
	
	vec2 offset = recalculateVec2(magdir.xy);

	vec4 fwdneighbour = texture(image, varyingTexCoord.xy + offset);
	vec4 backneighbour = texture(image, varyingTexCoord.xy - offset);

	outputColor = vec4(0.0);
	if(fwdneighbour.z < magdir.z
		&& backneighbour.z < magdir.z
		&& magdir.z > thresh)
		outputColor.xw = vec2(1.0);
}