#version 150 core

in vec2 varyingTexCoord;

uniform sampler2DRect image;
uniform float thresh;

const vec3 lum = vec3(0.2126, 0.7152, 0.0722);

out vec4 outputColor;

void main()
{
	vec2 gradient = vec2(0.0);
	gradient.x = dot(texture(image, varyingTexCoord + vec2(1.0,0.0)).xyz, lum) - dot(texture(image, varyingTexCoord - vec2(1.0,0.0)).xyz, lum);
	gradient.y = dot(texture(image, varyingTexCoord + vec2(0.0,1.0)).xyz, lum) - dot(texture(image, varyingTexCoord - vec2(0.0,1.0)).xyz, lum);

	outputColor.xy = (normalize(vec2(1.0)) + normalize(gradient)) / 2.0;
	outputColor.z = length(gradient);
	outputColor.w = 1.0;
}